// LesEtoiles.cpp: implementation of the LesEtoiles class.
//
//////////////////////////////////////////////////////////////////////

// class used to manage groups of Etoile

#define PI 3.14159265358979323846264338327950288419716939937510f
#include "LesEtoiles.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LesEtoiles::LesEtoiles()
{
}

// Load from file ( create the stream and call the Lire function )
void LesEtoiles::Charger(char * NomFichier)
{	ifstream fic (NomFichier,ios::in);
	if (fic.is_open())
	{	Lire(fic);
		fic.close();
	}
}

// Destructor
LesEtoiles::~LesEtoiles()
{	vector<Etoile *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	delete (*iter);
	}
}

// read from stream
int LesEtoiles::Lire(ifstream & lestream)
{	char ligne[150];
	char strTmp[5];
	char strTmp2[150];
	FILE * pFile;
	pFile=fopen("../data/name.txt","rt");
	fgets(ligne,150,pFile);
	strncpy(strTmp,ligne,4);	// HR number
	strTmp[4]='\0';
	unsigned int numHR = atoi(strTmp);
	strcpy(strTmp2,ligne+4);
	strTmp2[strlen(strTmp2)-1]='\0';

	printf("Loading star data...\n");
 	for(int i=1;i<=9110;i++)
	{	Etoile * e = new Etoile;
		(*e).Lire(lestream);
		Liste.push_back(e);
		if (numHR==(*e).HR)
		{	// assign the common name
			(*e).CommonName=strTmp2;
			// take the next one
			fgets(ligne,150,pFile);
			strncpy(strTmp,ligne,4);	// HR number
			strTmp[4]='\0';
			numHR = atoi(strTmp);
			strcpy(strTmp2,ligne+4);
			strTmp2[strlen(strTmp2)-1]='\0';
		}
	}
	printf("\n");
	fclose(pFile);
	return 0;
}

// Draw all the stars
void LesEtoiles::Afficher(float MagLimite)
{	ChampPrecalc=((Ouv+4.)*PI*((double)winW/winH)/360.); // Precalc the field of view for optimizations
	glBindTexture (GL_TEXTURE_2D, texIds[0]);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	vector<Etoile *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	(**iter).Afficher(MagLimite);
	}
}

// Look for a star by XYZ coords
int LesEtoiles::Rechercher(vec3_t Pos)
{	Pos.Normalize();
	vector<Etoile *>::iterator iter;
	Etoile * plusProche;
	float anglePlusProche=3.15;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	if ((**iter).XYZ[0]*Pos[0]+(**iter).XYZ[1]*Pos[1]+(**iter).XYZ[2]*Pos[2]>anglePlusProche)
		{	anglePlusProche=(**iter).XYZ[0]*Pos[0]+(**iter).XYZ[1]*Pos[1]+(**iter).XYZ[2]*Pos[2];
			plusProche=(*iter);
		}
	}
//	printf("PlusProche : Nom:%s HR:%i RA:%4.2f DE:%4.2f Dist:%4.5f\n",&(*plusProche).Name,(*plusProche).HR,(*plusProche).RaRad*12/3.141,(*plusProche).DecRad*180/3.141,anglePlusProche);
	if (anglePlusProche>498)
	{	Selectionnee=plusProche;
		return 0;
	}
	else return 1;
}

// Look for a star by Harvard Revised Catalog number
Etoile * LesEtoiles::Rechercher(unsigned int HR)
{return Liste[HR-1];
}
