// LesNebuleuses.cpp: implementation of the LesNebuleuses class.
//
//////////////////////////////////////////////////////////////////////

// class used to manage groups of Nebuleuse

#define PI 3.14159265358979323846264338327950288419716939937510f
#include "LesNebuleuses.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

LesNebuleuses::LesNebuleuses()
{
}

// Destructor
LesNebuleuses::~LesNebuleuses()
{	vector<Nebuleuse *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	delete (*iter);
	}
}

// read from stream
int LesNebuleuses::Lire(char * fileName)
{	FILE * fic;
	if (fic = fopen(fileName,"rt"))
	{	printf("Loading Nebulae data...\n");
		for(;;)
		{	Nebuleuse * e = new Nebuleuse;
			int temp = e->Lire(fic);
			if (temp==0) // fin fichier
			{	delete e;
				break;
			}
			if (temp==1 || temp==2) Liste.push_back(e);
		}
		printf("\n");
		fclose(fic);
	}
	return 0;
}

int LesNebuleuses::LireTexture()
{	vector<Nebuleuse *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	if ((*iter)->LireTexture()==0) return 0;
	}
	return 1;
}

// Draw all the Nebulaes
void LesNebuleuses::Afficher()
{	ChampPrecalc=((Ouv+4.)*PI*((double)winW/winH)/360.); // Precalc the field of view for optimizations
	glBindTexture (GL_TEXTURE_2D, texIds[0]);
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	vector<Nebuleuse *>::iterator iter;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	(**iter).Afficher();
	}
}

// Look for a nebulae by XYZ coords
int LesNebuleuses::Rechercher(vec3_t Pos)
{	Pos.Normalize();
	vector<Nebuleuse *>::iterator iter;
	Nebuleuse * plusProche;
	float anglePlusProche=3.15;
	for(iter=Liste.begin();iter!=Liste.end();iter++)
	{	if ((**iter).XYZ[0]*Pos[0]+(**iter).XYZ[1]*Pos[1]+(**iter).XYZ[2]*Pos[2]>anglePlusProche)
		{	anglePlusProche=(**iter).XYZ[0]*Pos[0]+(**iter).XYZ[1]*Pos[1]+(**iter).XYZ[2]*Pos[2];
			plusProche=(*iter);
		}
	}
	if (anglePlusProche>499.9)
	{	Selectionnee=plusProche;
		return 0;
	}
	else return 1;
}

