#include "AstroOps.h"
#include "PlanetData.h"
#include "DateOps.h"
#include "Vector.h"
#include <stdio.h>

#define PI 3.14159265358979323846264338327950288419716939937510
#define RADIANS 57.2958

vec3_t posPlaneteMars;
vec3_t posPlaneteTerre, posPlaneteVenus, posPlaneteJupiter;
vec3_t posPlaneteEqu;
float x;
float y;
float z;


void main(void)
{
	long jour=DateOps::dmyToDay(10, 06, 2001,0);
	int d;
	int m;
	long yy;
	printf("day : %f\n",jour);
	DateOps::dayToDmy( jour, d, m, yy, 0);
	cout << d << " " << m << " " << yy << endl;
	ObsInfo Guereins(4.5, 48.5, 1);
	PlanetData laPlaneteMars, laPlaneteTerre, laPlaneteVenus, laPlaneteJupiter;

	//-----------------------------------------
	laPlaneteMars.calc(MARS, jour, Guereins);
	posPlaneteMars[0]=(float)laPlaneteMars.equatorialLoc(1);
	posPlaneteMars[1]=(float)laPlaneteMars.equatorialLoc(2);
	posPlaneteMars[2]=(float)laPlaneteMars.equatorialLoc(0);


	x=posPlaneteMars[0];
	y=posPlaneteMars[1];
	z=posPlaneteMars[2];
	cout << "Mars    Rayon : "<< laPlaneteMars.radius() << "\ncoord " << x << " " << y << " " << z;
	float xz_dist = (float)sqrt( x*x + z*z );
	float mars_latitude = (float)atan2( y,xz_dist ) * (float)RADIANS;
	float mars_longitude = (float)atan2( x, z ) * (float)RADIANS;
	cout << "\nRA : " << laPlaneteMars.eclipticLon() * (float)RADIANS << " = " << mars_longitude+360 << "  DE : " << laPlaneteMars.eclipticLat() * (float)RADIANS << " = " << mars_latitude << "\n\n";
	//-----------------------------------------

	//-----------------------------------------
	laPlaneteTerre.calc(EARTH, jour, Guereins);
	posPlaneteTerre[0]=(float)laPlaneteTerre.equatorialLoc(1);
	posPlaneteTerre[1]=(float)laPlaneteTerre.equatorialLoc(2);
	posPlaneteTerre[2]=(float)laPlaneteTerre.equatorialLoc(0);
	x=posPlaneteTerre[0];
	y=posPlaneteTerre[1];
	z=posPlaneteTerre[2];
	cout << "Terre   Rayon : "<< laPlaneteTerre.radius() << "\ncoord " << x << " " << y << " " << z;;

	xz_dist = (float)sqrt( x*x + z*z );
	float terre_latitude = (float)atan( y/xz_dist ) * (float)RADIANS;
	float terre_longitude = (float)atan2( x, z ) * (float)RADIANS;
	cout << "\nRA : " << laPlaneteTerre.eclipticLon() * (float)RADIANS << " = " << terre_longitude+360 << "  DE : " << laPlaneteTerre.eclipticLat() * (float)RADIANS << " = " << terre_latitude << "\n\n";
	//-----------------------------------------

	//-----------------------------------------
	posPlaneteEqu=posPlaneteMars*(float)laPlaneteMars.radius()-posPlaneteTerre*(float)laPlaneteTerre.radius();

	x=posPlaneteEqu[0];
	y=posPlaneteEqu[1];
	z=posPlaneteEqu[2];

	xz_dist = (float)sqrt( x*x + z*z );
	float latitude = (float)atan( y/xz_dist ) * (float)RADIANS;
	float longitude = (float)atan2( x, z ) * (float)RADIANS;
	cout << "Mars equ RA=" <<  longitude+360 << "  DE=" << latitude << "\n\n";
	//-----------------------------------------	



	//-----------------------------------------
	laPlaneteVenus.calc(VENUS, jour, Guereins);
	posPlaneteVenus[0]=(float)laPlaneteVenus.eclipticLoc(1);
	posPlaneteVenus[1]=(float)laPlaneteVenus.eclipticLoc(2);
	posPlaneteVenus[2]=(float)laPlaneteVenus.eclipticLoc(0);
	cout << "Venus   Rayon : "<< laPlaneteVenus.radius();

	x=posPlaneteVenus[0];
	y=posPlaneteVenus[1];
	z=posPlaneteVenus[2];

	xz_dist = (float)sqrt( x*x + z*z );
	latitude = (float)atan( y/xz_dist ) * (float)RADIANS;
	longitude = (float)atan2( x, z ) * (float)RADIANS;
	cout << "RA : " << laPlaneteVenus.eclipticLon() * (float)RADIANS << " = " << longitude+360 << "  DE : " << laPlaneteVenus.eclipticLat() * (float)RADIANS << " = " << latitude << "\n\n";
	//-----------------------------------------

	//-----------------------------------------
	laPlaneteJupiter.calc(JUPITER, jour, Guereins);
	posPlaneteJupiter[0]=(float)laPlaneteJupiter.eclipticLoc(1);
	posPlaneteJupiter[1]=(float)laPlaneteJupiter.eclipticLoc(2);
	posPlaneteJupiter[2]=(float)laPlaneteJupiter.eclipticLoc(0);
	cout << "Jupiter Rayon : "<< laPlaneteJupiter.radius();

	x=posPlaneteJupiter[0];
	y=posPlaneteJupiter[1];
	z=posPlaneteJupiter[2];

	xz_dist = (float)sqrt( x*x + z*z );
	latitude = (float)atan( y/xz_dist ) * (float)RADIANS;
	longitude = (float)atan2( x, z ) * (float)RADIANS;
	cout << "RA : " << laPlaneteJupiter.eclipticLon() * (float)RADIANS << " = " << longitude << "  DE : " << laPlaneteJupiter.eclipticLat() * (float)RADIANS << " = " << latitude << "\n";
	//-----------------------------------------


}
